//---------------------------------------------------------------------------
// This routine manages the IQ balancing panel
//---------------------------------------------------------------------------
#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "ChanSkew.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "NakedSlider"
#pragma link "DrLabel"
#pragma link "FreeButton"
#pragma resource "*.dfm"

TSkewForm *SkewForm;

//---------------------------------------------------------------------------
__fastcall TSkewForm::TSkewForm(TComponent* Owner)
    : TForm(Owner), bypass(false)
{
    SkewForm->Top  = Screen->Height - SkewForm->Height;
    SkewForm->Left = Screen->DesktopWidth/2 - SkewForm->Width/2;
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::Memo1Enter(TObject *Sender)
{
//    OkButt->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::OkButtClick(TObject *Sender)
{
	ModalResult = mrOk;
	SkewForm->Hide();
	MainForm->stopAudio = false;
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::CancButtClick(TObject *Sender)
{
	MainForm->skew     = skewsave;
	MainForm->Qmult    = amplsave;
	MainForm->leftdly  = ldelsave;
	MainForm->rightdly = rdelsave;

	SkewForm->Hide();
	MainForm->stopAudio = false;
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::Memo1KeyPress(TObject *Sender, char &Key)
{
	Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::FormShow(TObject *Sender)
{
	MainForm->stopAudio = true;
	skewsave = MainForm->skew;
	amplsave = MainForm->Qmult;
	ldelsave = MainForm->leftdly;
	rdelsave = MainForm->rightdly;
	LLDly->Caption = ldelsave;
	if(ldelsave > 0) LLDly->Font->Color = clRed; else LLDly->Font->Color = clBlack;
	LRDly->Caption = rdelsave;
	if(rdelsave > 0) LRDly->Font->Color = clRed; else LRDly->Font->Color = clBlack;

	bypass = true;
	LAmpl->Caption = FormatFloat("0.0####;-0.0####", MainForm->Qmult);
	LevEq->Position = (MainForm->Qmult - 0.9) * 500. + 0.5;
	LevEqFine->Position = (MainForm->Qmult - 0.9 - (float)LevEq->Position / 500.)
						  * 50000. + LevEqFine->Max/2 + 0.5;

	LPhase->Caption = FormatFloat("#0.0## Deg.;-#0.0## Deg.", 180./PI * atan(MainForm->skew));
	bypass = true;
	PhaseSlider->Position = 1000. * MainForm->skew + 0.5;
	double frac = MainForm->skew - PhaseSlider->Position / 1000.;
	bypass = true;
	FinePhase->Position = frac * FinePhase->Max * 100000. + 0.5;
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::PhaseSliderChange(TObject *Sender)
{
	if(bypass) {bypass = false; return;}

	FinePhase->Position = 0;
	MainForm->skew = PhaseSlider->Position / 1000.;
	LPhase->Caption = FormatFloat("#0.0## Deg.;-#0.0## Deg.", 180./PI * atan(MainForm->skew));
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::LevEqChange(TObject *Sender)
{
	if(bypass) {bypass = false; return;}
	MainForm->Qmult = 0.9 + (float)LevEq->Position / 500.;
	LevEqFine->Position = LevEqFine->Max / 2;
	LAmpl->Caption = FormatFloat("0.0####;-0.0####", MainForm->Qmult);
}
//---------------------------------------------------------------------------

void __fastcall TSkewForm::ResetToZeroClick(TObject *Sender)
{
	LevEq->Position = LevEq->Max / 2;
	LevEqFine->Position = LevEqFine->Max / 2;
	PhaseSlider->Position = 0;
	FinePhase->Position = 0;

	MainForm->rightdly = 0;
	LRDly->Caption = MainForm->rightdly;  LRDly->Font->Color = clBlack;
	MainForm->leftdly = 0;
	LLDly->Caption = MainForm->leftdly;   LLDly->Font->Color = clBlack;
}
//---------------------------------------------------------------------------

void __fastcall TSkewForm::FinePhaseChange(TObject *Sender)
{
	if(bypass) {bypass = false; return;}

	MainForm->skew = PhaseSlider->Position / 1000. +
										   (float)FinePhase->Position / 100000.;
	LPhase->Caption = FormatFloat("#0.0## Deg.;-#0.0## Deg.", 180./PI * atan(MainForm->skew));
}
//---------------------------------------------------------------------------

void __fastcall TSkewForm::LevEqFineChange(TObject *Sender)
{
	if(bypass) {bypass = false; return;}
	MainForm->Qmult = 0.9 + (float)LevEq->Position / 500. +
					  (LevEqFine->Position - LevEqFine->Max/2) / 50000.;
	LAmpl->Caption = FormatFloat("0.0####;-0.0####", MainForm->Qmult);
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::DelayLeftClick(TObject *Sender)
{
	int k;

	MainForm->rightdly = 0;
	LRDly->Caption = MainForm->rightdly; LRDly->Font->Color = clBlack;

	k = MainForm->leftdly + 1;  if(k > 4) k = 0;
	MainForm->leftdly = k;      LLDly->Caption = MainForm->leftdly;
	if(k > 0) LLDly->Font->Color = clRed; else LLDly->Font->Color = clBlack;
}
//---------------------------------------------------------------------------
void __fastcall TSkewForm::DelayRightClick(TObject *Sender)
{
	int k;

	MainForm->leftdly = 0;
	LLDly->Caption = MainForm->leftdly;   LLDly->Font->Color = clBlack;

	k = MainForm->rightdly + 1;  if(k > 4) k = 0;
	MainForm->rightdly = k;      LRDly->Caption = MainForm->rightdly;
	if(k > 0) LRDly->Font->Color = clRed; else LRDly->Font->Color = clBlack;
}
//---------------------------------------------------------------------------

