// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'A3naloggauge.pas' rev: 11.00

#ifndef A3naloggaugeHPP
#define A3naloggaugeHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace A3naloggauge
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TStyle { LeftStyle, RightStyle, CenterStyle };
#pragma option pop

#pragma option push -b-
enum TFaceOption { ShowMargin, ShowCircles, ShowMainTicks, ShowSubTicks, ShowIndicatorMin, ShowIndicatorMid, ShowIndicatorMax, ShowValues, ShowCenter, ShowFrame, Show3D, ShowCaption };
#pragma option pop

typedef Set<TFaceOption, ShowMargin, ShowCaption>  TFaceOptions;

#pragma option push -b-
enum TAntialiased { aaNone, aaBiline, aaTriline, aaQuadral };
#pragma option pop

class DELPHICLASS TA3nalogGauge;
class PASCALIMPLEMENTATION TA3nalogGauge : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	Graphics::TColor FMinColor;
	Graphics::TColor FMidColor;
	Graphics::TColor FMaxColor;
	Graphics::TColor FFaceColor;
	Graphics::TColor FTicksColor;
	Graphics::TColor FValueColor;
	Graphics::TColor FCaptionColor;
	Graphics::TColor FArrowColor;
	Graphics::TColor FMarginColor;
	Graphics::TColor FCenterColor;
	Graphics::TColor FCircleColor;
	int FCenterRadius;
	int FCircleRadius;
	int FScaleAngle;
	int FMargin;
	TStyle FStyle;
	int FArrowWidth;
	int FNumMainTicks;
	int FLengthMainTicks;
	int FLengthSubTicks;
	TFaceOptions FFaceOptions;
	float FPosition;
	int FScaleValue;
	int FMinimum;
	int FMaximum;
	AnsiString FCaption;
	Classes::TNotifyEvent FOverMax;
	Classes::TNotifyEvent FOverMin;
	TAntialiased FAntiAliased;
	Graphics::TBitmap* FBackBitmap;
	Graphics::TBitmap* FFaceBitmap;
	Graphics::TBitmap* FAABitmap;
	__int64 FTicker;
	__int64 FPeriod;
	int FFrames;
	Classes::TNotifyEvent FOnFrames;
	void __fastcall SetFMinColor(Graphics::TColor C);
	void __fastcall SetFMidColor(Graphics::TColor C);
	void __fastcall SetFMaxColor(Graphics::TColor C);
	void __fastcall SetFFaceColor(Graphics::TColor C);
	void __fastcall SetFTicksColor(Graphics::TColor C);
	void __fastcall SetFValueColor(Graphics::TColor C);
	void __fastcall SetFCaptionColor(Graphics::TColor C);
	void __fastcall SetFArrowColor(Graphics::TColor C);
	void __fastcall SetFMarginColor(Graphics::TColor C);
	void __fastcall SetFCenterColor(Graphics::TColor C);
	void __fastcall SetFCircleColor(Graphics::TColor C);
	void __fastcall SetFCenterRadius(int I);
	void __fastcall SetFCircleRadius(int I);
	void __fastcall SetFScaleAngle(int I);
	void __fastcall SetFMargin(int I);
	void __fastcall SetFStyle(TStyle S);
	void __fastcall SetFArrowWidth(int I);
	void __fastcall SetFNumMainTicks(int I);
	void __fastcall SetFLengthMainTicks(int I);
	void __fastcall SetFLengthSubTicks(int I);
	void __fastcall SetFFaceOptions(TFaceOptions O);
	void __fastcall SetFPosition(float V);
	void __fastcall SetFScaleValue(int I);
	void __fastcall SetFMaximum(int I);
	void __fastcall SetFMinimum(int I);
	void __fastcall SetFCaption(const AnsiString S);
	void __fastcall SetFAntiAliased(TAntialiased V);
	int __fastcall GetAAMultipler(void);
	
protected:
	void __fastcall DrawScale(Graphics::TBitmap* Bitmap, int K);
	void __fastcall DrawArrow(Graphics::TBitmap* Bitmap, int K);
	void __fastcall RedrawScale(void);
	void __fastcall RedrawArrow(void);
	void __fastcall FastAntiAliasPicture(void);
	virtual void __fastcall Paint(void);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Msg);
	
public:
	__fastcall virtual TA3nalogGauge(Classes::TComponent* AOwner);
	__fastcall virtual ~TA3nalogGauge(void);
	
__published:
	__property Font ;
	__property Graphics::TColor MinColor = {read=FMinColor, write=SetFMinColor, nodefault};
	__property Graphics::TColor MidColor = {read=FMidColor, write=SetFMidColor, nodefault};
	__property Graphics::TColor MaxColor = {read=FMaxColor, write=SetFMaxColor, nodefault};
	__property Graphics::TColor FaceColor = {read=FFaceColor, write=SetFFaceColor, nodefault};
	__property Graphics::TColor TicksColor = {read=FTicksColor, write=SetFTicksColor, nodefault};
	__property Graphics::TColor ValueColor = {read=FValueColor, write=SetFValueColor, nodefault};
	__property Graphics::TColor CaptionColor = {read=FCaptionColor, write=SetFCaptionColor, nodefault};
	__property Graphics::TColor ArrowColor = {read=FArrowColor, write=SetFArrowColor, nodefault};
	__property Graphics::TColor MarginColor = {read=FMarginColor, write=SetFMarginColor, nodefault};
	__property Graphics::TColor CenterColor = {read=FCenterColor, write=SetFCenterColor, nodefault};
	__property Graphics::TColor CircleColor = {read=FCircleColor, write=SetFCircleColor, nodefault};
	__property int CenterRadius = {read=FCenterRadius, write=SetFCenterRadius, nodefault};
	__property int CircleRadius = {read=FCircleRadius, write=SetFCircleRadius, nodefault};
	__property int Angle = {read=FScaleAngle, write=SetFScaleAngle, nodefault};
	__property int Margin = {read=FMargin, write=SetFMargin, nodefault};
	__property TStyle Style = {read=FStyle, write=SetFStyle, nodefault};
	__property int ArrowWidth = {read=FArrowWidth, write=SetFArrowWidth, nodefault};
	__property int NumberMainTicks = {read=FNumMainTicks, write=SetFNumMainTicks, nodefault};
	__property int LengthMainTicks = {read=FLengthMainTicks, write=SetFLengthMainTicks, nodefault};
	__property int LengthSubTicks = {read=FLengthSubTicks, write=SetFLengthSubTicks, nodefault};
	__property TFaceOptions FaceOptions = {read=FFaceOptions, write=SetFFaceOptions, nodefault};
	__property float Position = {read=FPosition, write=SetFPosition};
	__property int Scale = {read=FScaleValue, write=SetFScaleValue, nodefault};
	__property int IndMaximum = {read=FMaximum, write=SetFMaximum, nodefault};
	__property int IndMinimum = {read=FMinimum, write=SetFMinimum, nodefault};
	__property AnsiString Caption = {read=FCaption, write=SetFCaption};
	__property TAntialiased AntiAliased = {read=FAntiAliased, write=SetFAntiAliased, nodefault};
	__property Classes::TNotifyEvent OnOverMax = {read=FOverMax, write=FOverMax};
	__property Classes::TNotifyEvent OnOverMin = {read=FOverMin, write=FOverMin};
	__property Classes::TNotifyEvent OnFrames = {read=FOnFrames, write=FOnFrames};
	__property int Frames = {read=FFrames, nodefault};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TA3nalogGauge(HWND ParentWindow) : Controls::TCustomControl(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace A3naloggauge */
using namespace A3naloggauge;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// A3naloggauge
