//---------------------------------------------------------------------------
#ifndef AdButtH
#define AdButtH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <math.h>

#define ATTR_NONE          0
#define ATTR_BOLD          1
#define ATTR_ITALIC        2
#define ATTR_UNDERLINE     4
#define ATTR_STRIKEOUT     8


//---------------------------------------------------------------------------

typedef enum{Small, Medium, Big, Grey} size;
//---------------------------------------------------------------------------
class PACKAGE TAdButt : public TGraphicControl
{
private:
   bool  Fdown;     // ON/OFF status of the button
   bool  Fradio;    // radio. behaves like a radio button
   int   CharWidth;
//   TColor FBackColor;  //Back Color
   String FCaption;   // caption of the button
   size   Fsize;
   TColor FfontColorON, FfontColorOFF;
   Graphics::TBitmap *ONBitmap;
   Graphics::TBitmap *OFFBitmap;
   HFONT  CaptionFont;
   HDC    hdcscreen, myhdc;
   TEXTMETRIC tm ;

   void __fastcall SetRadio(bool radio);
   void __fastcall SetDown(bool status);
   void __fastcall SetCaption(String caption);
   void __fastcall SetSize(size size);
   void __fastcall ResetBitmap(void);
   void __fastcall SetFontColorON(TColor color);
   void __fastcall SetFontColorOFF(TColor color);
   HFONT __fastcall myCreateFont (HDC hdc, char * szFaceName, int iDeciPtHeight,
                    int iDeciPtWidth, int iAttributes, BOOL fLogRes);

//   void __fastcall SetBackColor(const TColor ABackColor);

protected:
   void __fastcall Paint();

   DYNAMIC void __fastcall MouseDown(TMouseButton Button,
           TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseUp(TMouseButton Button,
           TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseMove(TShiftState Shift, int X, int Y);
   TMouseEvent fOnMouseDown;
   TMouseEvent fOnMouseUp;
   TMouseMoveEvent fOnMouseMove;

public:
   DYNAMIC void __fastcall Click();
   __fastcall TAdButt(TComponent* Owner);
   __fastcall ~TAdButt();

__published:
//   __property TColor BackColor={read=FBackColor, write=SetBackColor, default=clBlack};
   __property bool RadioButton={read=Fradio, write=SetRadio, default=false};
   __property bool Down={read=Fdown, write=SetDown, default=true};
   __property String Caption={read=FCaption, write=SetCaption};
   __property size Size={read=Fsize, write=SetSize, default=Small};
   __property TColor FontColorON ={read=FfontColorON,  write=SetFontColorON,  default=clCream};
   __property TColor FontColorOFF={read=FfontColorOFF, write=SetFontColorOFF, default=clGray};
   __property Enabled={default=true};
   __property OnClick;
   __property OnMouseDown={read=fOnMouseDown, write=fOnMouseDown};
   __property OnMouseUp={read=fOnMouseUp,     write=fOnMouseUp};
   __property OnMouseMove={read=fOnMouseMove, write=fOnMouseMove};

};
//---------------------------------------------------------------------------
#endif
