// CodeGear C++Builder
// Copyright (c) 1995, 2007 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Analogmeter.pas' rev: 11.00

#ifndef AnalogmeterHPP
#define AnalogmeterHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Analogmeter
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TCaptionPos { cpTop, cpBottom };
#pragma option pop

class DELPHICLASS TAnalogMeter;
class PASCALIMPLEMENTATION TAnalogMeter : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	Graphics::TBitmap* fTemp;
	Graphics::TBitmap* fMask;
	Graphics::TBitmap* fInvMask;
	Graphics::TBitmap* fBitmap;
	float fZeroAngle;
	#pragma pack(push,1)
	Types::TPoint fCentrePoint;
	#pragma pack(pop)
	#pragma pack(push,1)
	Types::TPoint fOuterHalfAxes;
	#pragma pack(pop)
	#pragma pack(push,1)
	Types::TPoint fInnerHalfAxes;
	#pragma pack(pop)
	int fFrameWidth;
	int fTxtHeight;
	float fOldValue;
	Classes::TNotifyEvent FonResize;
	Classes::TNotifyEvent FonChange;
	Classes::TNotifyEvent FonRiseAboveHigh;
	Classes::TNotifyEvent FonFallBelowHigh;
	Classes::TNotifyEvent FonRiseAboveLow;
	Classes::TNotifyEvent FonFallBelowLow;
	bool fEnableZoneEvents;
	Graphics::TBitmap* fBackGround;
	bool fShowBackground;
	int fBackGroundTop;
	int fBackGroundLeft;
	Graphics::TColor fColor;
	AnsiString fCaption;
	TCaptionPos fCaptionPos;
	Shortint fCaptionVAdj;
	Shortint fValueVAdj;
	float fMin;
	float fMax;
	float fValue;
	int fAngularRange;
	Byte fTickCount;
	float fLowZone;
	float fHighZone;
	bool fShowZones;
	bool fShowFrame;
	bool fShowTicks;
	bool fShowTicksScale;
	bool fShowValue;
	bool fAbbrTickVals;
	bool fLogScale;
	Byte fTickPrecision;
	Byte fTickDigits;
	Byte fValuePrecision;
	Byte fValueDigits;
	Graphics::TColor fTickColor;
	Graphics::TColor fHighZoneColor;
	Graphics::TColor fLowZoneColor;
	Graphics::TColor fOKZoneColor;
	bool fTransparentZones;
	Byte fNeedleWidth;
	Byte fKnobSize;
	void __fastcall SetShowZones(bool s);
	void __fastcall SetKnobSize(Byte s);
	void __fastcall SetNeedleWidth(Byte w);
	HIDESBASE void __fastcall SetColor(Graphics::TColor C);
	void __fastcall SetCaption(AnsiString s);
	void __fastcall SetCaptionPosition(TCaptionPos P);
	void __fastcall SetCaptionVAdj(Shortint V);
	void __fastcall SetValueVAdj(Shortint V);
	void __fastcall SetMin(float m);
	void __fastcall SetMax(float m);
	void __fastcall SetValue(float v);
	void __fastcall SetTickPrecision(Byte v);
	void __fastcall SetTickDigits(Byte v);
	void __fastcall SetValuePrecision(Byte v);
	void __fastcall SetValueDigits(Byte v);
	void __fastcall SetAngularRange(int r);
	void __fastcall SetTickCount(Byte t);
	void __fastcall SetLogScale(bool b);
	void __fastcall SetAbbrTick(bool b);
	void __fastcall SetLowZone(Byte percent);
	Byte __fastcall GetLowZone(void);
	void __fastcall SetHighZone(Byte percent);
	Byte __fastcall GetHighZone(void);
	void __fastcall SetShowValue(bool b);
	void __fastcall SetHighZoneColor(Graphics::TColor c);
	void __fastcall SetLowZoneColor(Graphics::TColor c);
	void __fastcall SetOKZoneColor(Graphics::TColor c);
	void __fastcall SetTickColor(Graphics::TColor c);
	void __fastcall SetShowTicks(bool b);
	void __fastcall SetShowTicksScale(bool b);
	void __fastcall SetShowFrame(bool b);
	HIDESBASE void __fastcall SetFont(Graphics::TFont* F);
	Graphics::TFont* __fastcall GetFont(void);
	void __fastcall SetLowZoneValue(float AValue);
	void __fastcall SetHighZoneValue(float AValue);
	void __fastcall SetBackground(const Graphics::TBitmap* Value);
	void __fastcall SetShowBackgound(const bool Value);
	void __fastcall SetBackGroundLeft(int v);
	void __fastcall SetBackGroundTop(int v);
	void __fastcall SetTransparentZones(const bool Value);
	AnsiString __fastcall AbbreviateTickString(float TickValue);
	AnsiString __fastcall NormalTickString(float TickValue);
	float __fastcall AngleOf(float v);
	float __fastcall LogAngleOf(float v);
	void __fastcall OptimizeSizes(void);
	void __fastcall ClearCanvas(void);
	void __fastcall DrawFrame(void);
	void __fastcall DrawZones(void);
	void __fastcall ClearInnerFace(void);
	void __fastcall DrawTicks(void);
	void __fastcall DrawTicksScale(void);
	void __fastcall DrawCaption(void);
	void __fastcall DrawPointer(void);
	void __fastcall DrawValue(void);
	void __fastcall DeleteOldValue(void);
	void __fastcall DrawOuterFace(void);
	void __fastcall DrawInnerFace(void);
	
protected:
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	virtual void __fastcall Paint(void);
	
public:
	__fastcall virtual TAnalogMeter(Classes::TComponent* AOwner);
	__fastcall virtual ~TAnalogMeter(void);
	void __fastcall ForceRedraw(void);
	
__published:
	__property Graphics::TBitmap* BackGround = {read=fBackGround, write=SetBackground};
	__property bool ShowBackground = {read=fShowBackground, write=SetShowBackgound, nodefault};
	__property int BackGroundTop = {read=fBackGroundTop, write=SetBackGroundTop, nodefault};
	__property int BackGroundLeft = {read=fBackGroundLeft, write=SetBackGroundLeft, nodefault};
	__property AnsiString Caption = {read=fCaption, write=SetCaption};
	__property TCaptionPos CaptionPosition = {read=fCaptionPos, write=SetCaptionPosition, default=0};
	__property Shortint CaptionVertAdj = {read=fCaptionVAdj, write=SetCaptionVAdj, default=0};
	__property Shortint ValueVertAdj = {read=fValueVAdj, write=SetValueVAdj, default=0};
	__property float Min = {read=fMin, write=SetMin};
	__property float Max = {read=fMax, write=SetMax};
	__property float Value = {read=fValue, write=SetValue};
	__property Byte TickPrecision = {read=fTickPrecision, write=SetTickPrecision, default=7};
	__property Byte TickDigits = {read=fTickDigits, write=SetTickDigits, default=1};
	__property bool LogScale = {read=fLogScale, write=SetLogScale, default=0};
	__property bool TickValAbbr = {read=fAbbrTickVals, write=SetAbbrTick, default=0};
	__property Byte ValuePrecision = {read=fValuePrecision, write=SetValuePrecision, default=7};
	__property Byte ValueDigits = {read=fValueDigits, write=SetValueDigits, default=1};
	__property int AngularRange = {read=fAngularRange, write=SetAngularRange, default=270};
	__property Byte TickCount = {read=fTickCount, write=SetTickCount, default=7};
	__property Byte LowZone = {read=GetLowZone, write=SetLowZone, default=10};
	__property Byte HighZone = {read=GetHighZone, write=SetHighZone, default=90};
	__property Graphics::TColor HighZoneColor = {read=fHighZoneColor, write=SetHighZoneColor, default=255};
	__property Graphics::TColor LowZoneColor = {read=fLowZoneColor, write=SetLowZoneColor, default=65535};
	__property Graphics::TColor OKZoneColor = {read=fOKZoneColor, write=SetOKZoneColor, default=-16777194};
	__property bool TransparentZones = {read=fTransparentZones, write=SetTransparentZones, nodefault};
	__property float LowZoneValue = {read=fLowZone, write=SetLowZoneValue};
	__property float HighZoneValue = {read=fHighZone, write=SetHighZoneValue};
	__property Byte KnobSize = {read=fKnobSize, write=SetKnobSize, nodefault};
	__property Byte NeedleWidth = {read=fNeedleWidth, write=SetNeedleWidth, nodefault};
	__property Graphics::TColor TickColor = {read=fTickColor, write=SetTickColor, default=0};
	__property bool ShowTicks = {read=fShowTicks, write=SetShowTicks, default=1};
	__property bool ShowTicksScale = {read=fShowTicksScale, write=SetShowTicksScale, default=1};
	__property bool ShowZones = {read=fShowZones, write=SetShowZones, default=1};
	__property bool ShowFrame = {read=fShowFrame, write=SetShowFrame, default=1};
	__property bool ShowValue = {read=fShowValue, write=SetShowValue, default=1};
	__property Classes::TNotifyEvent onResize = {read=FonResize, write=FonResize};
	__property Classes::TNotifyEvent onChange = {read=FonChange, write=FonChange};
	__property bool EnableZoneEvents = {read=fEnableZoneEvents, write=fEnableZoneEvents, default=1};
	__property Classes::TNotifyEvent onRiseAboveHigh = {read=FonRiseAboveHigh, write=FonRiseAboveHigh};
	__property Classes::TNotifyEvent onFallBelowHigh = {read=FonFallBelowHigh, write=FonFallBelowHigh};
	__property Classes::TNotifyEvent onRiseAboveLow = {read=FonRiseAboveLow, write=FonRiseAboveLow};
	__property Classes::TNotifyEvent onFallBelowLow = {read=FonFallBelowLow, write=FonFallBelowLow};
	__property Align  = {default=0};
	__property Graphics::TColor Color = {read=fColor, write=SetColor, nodefault};
	__property Graphics::TFont* Font = {read=GetFont, write=SetFont};
	__property ParentColor  = {default=1};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ShowHint ;
	__property Visible  = {default=1};
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TAnalogMeter(HWND ParentWindow) : Controls::TCustomControl(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Analogmeter */
using namespace Analogmeter;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Analogmeter
