#ifndef FlatButtonH
#define FlatButtonH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
class TFlatButton : public TGraphicControl
{
private:
   Graphics::TBitmap	*FGlyph;
   TImageList *FImageList;
   TColor 	FTransparentColor;
   int FNumGlyph;
   AnsiString FCaption;
   bool FMouseOver;
   bool ButtonPushed;
   void __fastcall SetGlyph(Graphics::TBitmap *AGlyph);
   void __fastcall SetCaption(AnsiString Value);
   void __fastcall SetNumGlyph(int Value);
   void __fastcall InitImageList(TImageList *ImageList,
   						Graphics::TBitmap *Bitmap,int Count);
protected:
   void __fastcall Paint();
//   void __fastcall Click();
//   void __fastcall MouseMove(TShiftState Shift,int X,int Y);
   void __fastcall WMButtonUp(Messages::TWMMouse &Message);
   void __fastcall WMButtonDown(Messages::TWMMouse &Message);
   void __fastcall CMMouseLeave(TMessage &Message);
   void __fastcall CMMouseEnter(TMessage &Message);
public:
   __fastcall TFlatButton(TComponent* Owner);
   __fastcall ~TFlatButton();
__published:
   __property OnClick;
   __property OnMouseDown;
   __property OnMouseMove;
   __property OnMouseUp;
   __property AnsiString Caption={read=FCaption,write=SetCaption};
   __property Font;
   __property Hint;
   __property ShowHint;
   __property Enabled;
   __property Visible;
   __property Name;
   __property Graphics::TBitmap *Glyph={read=FGlyph,write=SetGlyph};
   __property int NumGlyph={read=FNumGlyph,write=SetNumGlyph};

BEGIN_MESSAGE_MAP
	MESSAGE_HANDLER(WM_LBUTTONUP,Messages::TWMMouse,WMButtonUp)
	MESSAGE_HANDLER(WM_LBUTTONDOWN,Messages::TWMMouse,WMButtonDown)
    MESSAGE_HANDLER(CM_MOUSELEAVE,TMessage,CMMouseLeave)
    MESSAGE_HANDLER(CM_MOUSEENTER,TMessage,CMMouseEnter)
END_MESSAGE_MAP(TGraphicControl)

};
//---------------------------------------------------------------------------
#endif

