//---------------------------------------------------------------------------
#ifndef ModeButtH
#define ModeButtH
//---------------------------------------------------------------------------
#include <vcl\SysUtils.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Forms.hpp>
#include <math.h>

typedef  enum {bAM, bECSS, bFM, bLSB, bUSB, bCW, bDRM} type;
//---------------------------------------------------------------------------
class PACKAGE TModeButt : public TGraphicControl
{
private:
   bool  Fdown;     // ON/OFF status of the button
   bool  Fradio;    // radio. behaves like a radio button
   type  Ftype;
   Graphics::TBitmap *ONBitmap;
   Graphics::TBitmap *OFFBitmap;

   void __fastcall SetRadio(bool radio);
   void __fastcall SetMode(type type);
   void __fastcall SetDown(bool status);
   void __fastcall ResetBitmap(void);

protected:
   void __fastcall Paint();

   DYNAMIC void __fastcall MouseDown(TMouseButton Button,
           TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseUp(TMouseButton Button,
           TShiftState Shift, int X, int Y);
   DYNAMIC void __fastcall MouseMove(TShiftState Shift, int X, int Y);
   TMouseEvent fOnMouseDown;
   TMouseEvent fOnMouseUp;
   TMouseMoveEvent fOnMouseMove;

public:
   DYNAMIC void __fastcall Click();
   __fastcall TModeButt(TComponent* Owner);
   __fastcall ~TModeButt();

__published:
   __property bool RadioButton={read=Fradio, write=SetRadio, default=true};
   __property bool Down={read=Fdown, write=SetDown, default=false};
   __property type Type={read=Ftype, write=SetMode, default=bAM};
   __property Enabled={default=true};
   __property OnClick;
   __property OnMouseDown={read=fOnMouseDown, write=fOnMouseDown};
   __property OnMouseUp={read=fOnMouseUp,     write=fOnMouseUp};
   __property OnMouseMove={read=fOnMouseMove, write=fOnMouseMove};

};
//---------------------------------------------------------------------------
#endif
