//---------------------------------------------------------------------------
// Despite its name, the main passband filters of Winrad are not performed here
// Here only some initializations are done, for filters that will be used later
//---------------------------------------------------------------------------

#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "Filters.h"

//---------------------------------------------------------------------------
static float HPFcoef_11k[12] =   // 3rd order elliptic filter, fs=11025 Hz,
								 // hi-pass, fcut = 150 Hz, ripple = 2dB
 {  1.,  -1.9999374905129277,  1.,  1.,  -1.9571775980131627,   0.96526631928081519,
	1.,  -1.,                  0.,  1.,  -0.79282675867370578,  0,
 };

static NSPIirState HPFState;
static double dummy1[8];  // debordamento della HPFState......
static NSPIirState HPFStateStereo;   // AlpAdd
static double dummy2[8];  // debordamento della HPFState......
//---------------------------------------------------------------------------

void FiltersInit()
{
	static bool inited = false;

	if(inited) return;
	nspsIirInitBq(NSP_IirDefault, HPFcoef_11k, 2, &HPFState);
	nspsIirInitBq(NSP_IirDefault, HPFcoef_11k, 2, &HPFStateStereo);  // AlpAdd

	nspdFirLowpass(0.1, MainForm->PMLPdtaps, PMLPLENW, NSP_WinBlackmanOpt, 1);

	for(int k = 0; k < PMLPLENW; k++)
	  MainForm->PMLPftapsWide[k].re = MainForm->PMLPftapsWide[k].im = MainForm->PMLPdtaps[k];

	nspcFirInit(MainForm->PMLPftapsWide, PMLPLENW, NULL, &MainForm->PMLPstateWide);

	nspdFirLowpass(0.005, MainForm->PMLPdtaps, PMLPLENN, NSP_WinBlackmanOpt, 1);

	for(int k = 0; k < PMLPLENN; k++)
	  MainForm->PMLPftapsNarr[k].re = MainForm->PMLPftapsNarr[k].im = MainForm->PMLPdtaps[k];

	nspcFirInit(MainForm->PMLPftapsNarr, PMLPLENN, NULL, &MainForm->PMLPstateNarr);

	inited = true;
}
//---------------------------------------------------------------------------
void __fastcall HighPassFilter(const float *in, float *out, int size)
{
	nspsbIir(&HPFState, in, out, size);
}
//---------------------------------------------------------------------------
void __fastcall HighPassFilterStereo(const float *in, float *out, int size)
{
	nspsbIir(&HPFStateStereo, in, out, size);
}
