//---------------------------------------------------------------------------
// Choose here which MME driver to use
//---------------------------------------------------------------------------

#include <vcl.h>
#include "pch.h"
#pragma  hdrstop

#include "SelCard.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "DrLabel"
#pragma link "FreeButton"
#pragma resource "*.dfm"

TSelCardForm *SelCardForm;

//---------------------------------------------------------------------------
__fastcall TSelCardForm::TSelCardForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSelCardForm::CancButtClick(TObject *Sender)
{
    MainForm->devIdIn  = SaveIDIn;
    MainForm->devIdOut = SaveIDOut;
    strcpy(MainForm->devNameIn,  SaveNameIn);
    strcpy(MainForm->devNameOut, SaveNameOut);
    ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TSelCardForm::FormShow(TObject *Sender)
{
    WAVEINCAPS  InCaps;
    WAVEOUTCAPS OutCaps;
    MMRESULT  ierr;
    int k, numDevIn, numDevOut;

    CancButt->Enabled = !MF->mustChoose;
    CancButt->Font->Color = CancButt->Enabled ? clBlack : clGray;
// remove a previously ASIO driver
    if(*MF->asioName) asioDrivers->removeCurrentDriver();

    SaveIDIn  = MainForm->devIdIn;
    SaveIDOut = MainForm->devIdOut;
    strcpy(SaveNameIn,  MainForm->devNameIn);
    strcpy(SaveNameOut, MainForm->devNameOut);

    if ((numDevIn = waveInGetNumDevs()) <= 0 ||
        (numDevOut = waveOutGetNumDevs()) <= 0)
       ModalResult = mrCancel;

    CardInBox->Clear();
    for(k=0; k<numDevIn; k++)
    {
       ierr = waveInGetDevCaps(k, &InCaps, sizeof(InCaps));
       if(ierr != MMSYSERR_NOERROR) continue;
       if(InCaps.dwFormats & WAVE_FORMAT_4S16 == 0)  // 44100 stereo not
         continue;                                   // supported, skip
       CardInBox->Items->Add(InCaps.szPname);
    }
    CardInBox->ItemIndex  = MainForm->devIdIn;
    CardInBoxClick(Sender);

    CardOutBox->Clear();
    for(k=0; k<numDevOut; k++)
    {
       ierr = waveOutGetDevCaps(k, &OutCaps, sizeof(OutCaps));
       if(ierr != MMSYSERR_NOERROR) continue;
       if(OutCaps.dwFormats & WAVE_FORMAT_4S16 == 0)  // 44100 stereo not
         continue;                                    // supported, skip
       CardOutBox->Items->Add(OutCaps.szPname);
    }
    CardOutBox->ItemIndex = MainForm->devIdOut;
    CardOutBoxClick(Sender);

}
//---------------------------------------------------------------------------
void __fastcall TSelCardForm::CardInBoxClick(TObject *Sender)
{
    MainForm->devIdIn   = CardInBox->ItemIndex;
    strcpy(MainForm->devNameIn,
                     CardInBox->Items->Strings[CardInBox->ItemIndex].c_str());
}
//---------------------------------------------------------------------------
void __fastcall TSelCardForm::CardOutBoxClick(TObject *Sender)
{
    MainForm->devIdOut = CardOutBox->ItemIndex;
    strcpy(MainForm->devNameOut,
                     CardOutBox->Items->Strings[CardOutBox->ItemIndex].c_str());
}
//---------------------------------------------------------------------------
void __fastcall TSelCardForm::OkButtClick(TObject *Sender)
{
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------

