#ifndef Sound_ioH
#define Sound_ioH

#include "main.h"
#include "defines.h"
#include <nsp.h>

#define WAVE_FORMAT_EXTENSIBLE          0xFFFE

#define SPEAKER_FRONT_LEFT              0x1
#define SPEAKER_FRONT_RIGHT             0x2
#define SPEAKER_FRONT_CENTER            0x4
#define SPEAKER_LOW_FREQUENCY           0x8
#define SPEAKER_BACK_LEFT               0x10
#define SPEAKER_BACK_RIGHT              0x20
#define SPEAKER_FRONT_LEFT_OF_CENTER    0x40
#define SPEAKER_FRONT_RIGHT_OF_CENTER   0x80
#define SPEAKER_BACK_CENTER             0x100
#define SPEAKER_SIDE_LEFT               0x200
#define SPEAKER_SIDE_RIGHT              0x400
#define SPEAKER_TOP_CENTER              0x800
#define SPEAKER_TOP_FRONT_LEFT          0x1000
#define SPEAKER_TOP_FRONT_CENTER        0x2000
#define SPEAKER_TOP_FRONT_RIGHT         0x4000
#define SPEAKER_TOP_BACK_LEFT           0x8000
#define SPEAKER_TOP_BACK_CENTER         0x10000
#define SPEAKER_TOP_BACK_RIGHT          0x20000

typedef struct {
  WAVEFORMATEX  Format;
  union {
    WORD  wValidBitsPerSample;
    WORD  wSamplesPerBlock;
    WORD  wReserved;
  } Samples;
  DWORD   dwChannelMask;
  GUID    SubFormat;
} WAVEFORMATEXTENSIBLE, *PWAVEFORMATEXTENSIBLE;

//
// function prototypes
//
bool            SoundOpenIn(void);
static MMRESULT SoundStartIn(void);
static void     SoundStopIn(void);
void            SoundCloseIn(void);

bool            SoundOpenOut(void);
static MMRESULT SoundStartOut(bool secondTry);
static void     SoundStopOut(void);
void            SoundCloseOut(void);

int    __fastcall GetExtIOdata(void);

void            BufFree(void);
static VOID CALLBACK SoundProcIn   (HWAVEIN  , UINT , DWORD, DWORD, DWORD );
static VOID CALLBACK SoundProcOut  (HWAVEIN  , UINT , DWORD, DWORD, DWORD );

extern void   __fastcall fatal(char *);
extern void   __fastcall ReQueIn(int idx);
extern void   __fastcall ReQueOut(int idx);
extern void   __fastcall ResetOut(void);
//extern bool   __fastcall getBufPtrIn(int& idx, short* inL, short* inR);
extern bool   __fastcall getBufPtrIn(int& idx, void* inL, void* inR);
extern short* __fastcall getBufPtrOut(int& idx);
extern void   __fastcall GetCurrentCard(void);
extern void   __fastcall PutCurrentCard(void);
extern void              extIOCallback(int cnt, int status, float IQoffset, void *IQdata);


#endif
