//---------------------------------------------------------------------------

#ifndef MyClassesH
#define MyClassesH

#include <nsp.h>

//---------------------------------------------------------------------------
class TExtLoDigits
{
public:
        int  idx, value;
        bool bright;

        bool __fastcall Inc(void);
        bool __fastcall Dec(void);
        void __fastcall Init(int idx);
        void __fastcall SetVal(int n);
        void __fastcall Show(TImage* img);
};
//----------------------------------------------------------------------
class TNCODigits
{
public:
        int  idx, value;
        bool bright;
        static bool negative;

        bool __fastcall Inc(void);
        bool __fastcall Dec(void);
        void __fastcall Init(int idx);
        void __fastcall SetVal(int n);
        void __fastcall Show(TImage* img);
};
//----------------------------------------------------------------------
class TLog
{
private :
        FILE *f;
public:
        void OpenLog(void);
		void WriteLog(char *s, int v);
		void WriteMag(float m1, float m2);
		void WriteTime(char *s, float elapsed);
		void WriteIQ(SCplx IQpair);
		void WriteFloat(float f);

};
//----------------------------------------------------------------------
class TProcessOut : public TThread
{
private:
protected:
        void __fastcall Execute();
public:
        __fastcall TProcessOut(bool CreateSuspended);
        __fastcall ~TProcessOut();
};
//----------------------------------------------------------------------
class TProcessFF1 : public TThread
{
private:
		int interval, loopctr, tint;

protected:
		void __fastcall Execute();

public:
		bool   firstpass, wf1time;
		int    size;
		SCplx  FF1array[FF1SMAX], FF1data[FF1SMAX], FF1out[FF1SMAX/2 + 1],
			   PolyFF1[POLYFAC * FF1SMAX], PolyQue[POLYFAC * FF1SMAX];
		float  FF1input[FF1SMAX], FF1spectrum[FF1SMAX];
		SCplx  sin3[POLYFAC * FF1SMAX], sin5[POLYFAC * FF1SMAX],
			   wnuttall[POLYFAC * FF1SMAX];

		void __fastcall ScrollWF1(void);
		void __fastcall PaintWF1(void);
		void __fastcall ComputeFF1IQ(void);
		void __fastcall DynW(void);
		void __fastcall DoSync(void);

		__fastcall TProcessFF1(bool CreateSuspended);
};
//----------------------------------------------------------------------
class TProcessFF2 : public TThread
{
private:
protected:
		void __fastcall Execute();

public:
		bool   firstpass;
		int    size;
		float  FF2array[FF2SMAX], PolyFF2[POLYFAC * FF2SMAX],
			   PolyQue[POLYFAC * FF2SMAX];
		SCplx  FF2data[FF2SMAX];
		float  sin3[POLYFAC * FF2SMAX], sin5[POLYFAC * FF2SMAX],
			   wnuttall[POLYFAC * FF2SMAX];

		void __fastcall ScrollWF2(void);
		void __fastcall PaintWF2(void);
		void __fastcall ComputeFF2(void);

		__fastcall TProcessFF2(bool CreateSuspended);
};
//----------------------------------------------------------------------
class TDnSample
{
public:
		__fastcall TDnSample(void);
		__fastcall ~TDnSample();
		int  __fastcall dnsample(SCplx *in, SCplx *out, int len);
		void __fastcall setDnfactor(float fac);

private:
		float idx, fac;
		int   cnt, idxint, sincidx;
		SCplx *tmp;
};
//---------------------------------------------------------------------------
class TProcessIn : public TThread
{

protected:
		void __fastcall Execute();
		char FF1fsamp_ready;
public:
		int    wreadlen, sleeptime, offs, dstLen, hangcnt, inIdx;
		int    outLup[BUFSIZE*MAXDOWN], outRup[BUFSIZE*MAXDOWN];
		int    inL[BUFSIZE], inR[BUFSIZE];
		float  phase;
		bool __fastcall ProcessAudio(void *inL,  void *inR,
									 int  *outL, int  *outR);
		void __fastcall UpdateVU(void);
		void __fastcall UpdatePM(void);
		__fastcall TProcessIn(bool CreateSuspended);
	void __fastcall WideFM_PreDecProc(SCplx *tmpSamp);
	void __fastcall WideFM_PostDecProc_1(SCplx *FF1fsamp,
				float *FF2audio, float *FF2audioStereo);
	void __fastcall WideFM_PostDecProc_2(SCplx *FF1fsamp,
				float *FF2audio, float *FF2audioStereo);

};
//----------------------------------------------------------------------
#endif

